package LeidenUniv.Tracking;
import java.util.ArrayList;
import java.util.List;
import ij.*;
public class OAindices {

	OAicolumns[] indices;
	int sizeofOAindices;
	
	OAindices(int size){
		
		indices = new OAicolumns[size];
		
		for (int i=0; i<size; i++){
			indices[i] = new OAicolumns();
		}		
		sizeofOAindices = size;		
	}
	
	public boolean get(int spaceindex, int index){
		try {
			indices[spaceindex].get(index);
			if (indices[spaceindex].get(index)!=0){
				getreal(spaceindex, index);
				return true;
			} else {
			return false;
			}
		} catch (IndexOutOfBoundsException e) {
			return false;
		}
		 
	}
	
	public int getreal(int spaceindex, int index){
		return indices[spaceindex].get(index);
	}
	
	public void add(int spaceindex, int FociIndex){
		indices[spaceindex].addFociIndex(indices[spaceindex].size(), FociIndex);
	}
	
	public void set(int spaceindex, int i, int FociIndex){
		indices[spaceindex].addFociIndex(i, FociIndex);
	}
	
	public int size(int index){
		return indices[index].size();
	}
	
	public Integer[] find(int index, int FociIndex){
		List<Integer> indexlist = new ArrayList<Integer>(1);

		// int[] indices = new int[0];
		for (int i=0; i<indices[index].size(); i++){
			if (indices[index].get(i) == FociIndex){
				indexlist.add(i);	
			}
		}
		
		Integer[] returnvalue = indexlist.toArray(new Integer[indexlist.size()]);
		return returnvalue;
	}	
	
	public void print(){
		for (int i=0; i<this.sizeofOAindices; i++){
 // loop through all OAI columns
			for (int j=0; j<this.size(i); j++){
 // run through the size of the AOI column object
				//for (int k=0; k<this.sizeofOAindices; k++){
					IJ.log(""+indices[i].get(j));
				//}
			}	
		}
	}
	
	public void resize(int colnum){
		int maxsize = indices[colnum].size();
		
		//for (int i=colnum+1; i<this.sizeofOAindices; i++) {
		  for (int i=0; i<this.sizeofOAindices; i++){
		  	for (int j=indices[i].size(); j<maxsize; j++){
				indices[i].addFociIndex(j, 0);
			}
	}
	}
}

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
