package LeidenUniv.Tracking;


import java.io.File;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
//12
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import ij.*;
import ij.IJ.*;
import ij.gui.*;
import ij.WindowManager; //10
import ij.ImagePlus; 
import ij.measure.*;

public class PlotDataJoost {

static String[] LineColor={"black", "blue", "cyan", "green", "yellow", "orange", "red", "magenta","white"};
static double oldy;
static double oldx;
static double x;
static double y;
static int d;
static int e;
static int c;
static	ImagePlus imp;
static int counter;
	
	public static void plot(OAindices OAi, ObjectArray OA, String ColorSet, ImagePlus imp){
		counter=0;
		imp = WindowManager.getCurrentImage();
			// loop through OA and create elements
			imp.hide();
			IJ.run(imp, "RGB Color", "");
			IJ.run(imp, "Line Width...", "line=1");
			for (int i=0; i<OAi.size(0); i++){ // loop through rows
				
counter++;
				if (counter>8){
					counter=1;
				}
						oldy=0;
						oldx=0;	
						d=0;		
				
				for (int j=0; j<OAi.sizeofOAindices; j++){ // loop through cols
					
					d=j;
					if (OAi.get(j,i)){	
						
if (ColorSet.equals("timed")){
							while ((d-7)>=0){
							d=d-7;						
							}
							c=d;
							IJ.run("Colors...", "foreground=" + LineColor[c] + " background=orange selection=magenta");
						} else if (ColorSet.equals("Object")){
							IJ.run("Colors...", "foreground=" + LineColor[counter] + " background=orange selection=magenta");
							
						} else {
							for (int q=0;q<LineColor.length;q++){
								if (LineColor[q].equals(ColorSet)){
									int cc=q;
									IJ.run("Colors...", "foreground=" + LineColor[cc] + " background=orange selection=magenta");
								}
							}
						}
						if (oldy>0){
							imp.setSlice(j+1);
							Calibration c =imp.getCalibration();
							x=OA.getreal(j,i).x_coord;
							y=OA.getreal(j,i).y_coord;
							// add scale
							imp.setRoi(new Line(oldx/c.pixelWidth, oldy/c.pixelHeight, x/c.pixelWidth, y/c.pixelHeight));
							for (e=j; e<OAi.sizeofOAindices; e++){
							imp.setSlice(e+1);
							if (!(ColorSet.equals("none"))){
								IJ.run(imp, "Draw", "slice");
							}
						}
					
							oldx=x;
							oldy=y;
						} else {
							oldy=OA.getreal(j,i).y_coord;
							oldx=OA.getreal(j,i).x_coord;

						}
						
					}	
					
				}
				
			}
			imp.show();

			// write the content into xml file
			// Output to console for testing
			//StreamResult result = new StreamResult(System.out);
 
		}
	}

	
